Index: code/branches/presentationHS12/src/modules/objects/CMakeLists.txt
===================================================================
--- code/branches/presentationHS12/src/modules/objects/CMakeLists.txt	(revision 9481)
+++ code/branches/presentationHS12/src/modules/objects/CMakeLists.txt	(revision 9503)
@@ -5,4 +5,5 @@
   Script.cc
   SpaceBoundaries.cc
+  Turret.cc
 )
 
Index: code/branches/presentationHS12/src/modules/objects/ObjectsPrereqs.h
===================================================================
--- code/branches/presentationHS12/src/modules/objects/ObjectsPrereqs.h	(revision 9481)
+++ code/branches/presentationHS12/src/modules/objects/ObjectsPrereqs.h	(revision 9503)
@@ -73,4 +73,5 @@
     class Script;
     class SpaceBoundaries;
+    class Turret;
 
     // collisionshapes
Index: code/branches/presentationHS12/src/modules/objects/Turret.cc
===================================================================
--- code/branches/presentationHS12/src/modules/objects/Turret.cc	(revision 9503)
+++ code/branches/presentationHS12/src/modules/objects/Turret.cc	(revision 9503)
@@ -0,0 +1,85 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Marian Runo
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "Turret.h"
+#include "core/CoreIncludes.h"
+#include "OgreQuaternion.h"
+#include "core/XMLPort.h"
+#include "controllers/WaypointPatrolController.h"
+
+namespace orxonox
+{
+    CreateFactory(Turret);
+
+    /**
+     * @brief Constructor
+     */
+    Turret::Turret(BaseObject* creator) : SpaceShip(creator)
+    {
+        RegisterObject(Turret);
+        this->controller_ = new WaypointPatrolController(this);
+    }
+
+    /**
+     * @brief Destructor
+     */
+    Turret::~Turret()
+    {
+
+    }
+
+
+    void Turret::rotatePitch(const Vector2& value)
+    {
+    	orxout()<< "Turret rotate Pitch"<< endl;
+
+    	const Quaternion& orient = this->getOrientation();
+    	Radian pitch = orient.getPitch();
+
+    	if((value.x > 0 && pitch < Radian(180)) || (value.x < 0 && pitch > Radian(0)))
+    		SpaceShip::rotatePitch(value);
+    }
+
+
+    void Turret::setAlertnessRadius(float value)
+    {
+    	this->controller_->setAlertnessRadius(value);
+    }
+    float Turret::getAlertnessRadius()
+    {
+    	return this->controller_->getAlertnessRadius();
+    }
+
+    void Turret::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(Turret, XMLPort, xmlelement, mode);
+        XMLPortParam(Turret, "alertnessRadius", setAlertnessRadius, getAlertnessRadius, xmlelement, mode).defaultValues("400");
+    }
+
+
+}
Index: code/branches/presentationHS12/src/modules/objects/Turret.h
===================================================================
--- code/branches/presentationHS12/src/modules/objects/Turret.h	(revision 9503)
+++ code/branches/presentationHS12/src/modules/objects/Turret.h	(revision 9503)
@@ -0,0 +1,68 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Marian Runo
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file Turret.h
+    @brief Definition of the Turret class.
+    @ingroup Objects
+*/
+
+#ifndef _Turret_H__
+#define _Turret_H__
+
+#include "objects/ObjectsPrereqs.h"
+
+#include "worldentities/pawns/SpaceShip.h"
+
+namespace orxonox
+{
+    class _ObjectsExport Turret : public SpaceShip
+    {
+        public:
+            Turret(BaseObject* creator);
+            virtual ~Turret();
+
+            //virtual void tick(float dt);
+
+            virtual void rotatePitch(const Vector2& value);
+
+            void setAlertnessRadius(float value);
+            float getAlertnessRadius();
+
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+
+        protected:
+            WaypointPatrolController* controller_;
+        private:
+
+    };
+}
+
+#endif
+