Index: code/branches/presentationHS12/data/levels/gallery.oxw
===================================================================
--- code/branches/presentationHS12/data/levels/gallery.oxw	(revision 9503)
+++ code/branches/presentationHS12/data/levels/gallery.oxw	(revision 9505)
@@ -68,5 +68,5 @@
       <Model position="0,20,-40" yaw="90" pitch="-90" roll="0" scale="2" mesh="LightningGun.mesh" />
       <Model position="0,40,-40" yaw="90" pitch="-90" roll="0" scale="2" mesh="LightningGun-s.mesh" />
-      <Model position="0,60,-40" yaw="90" pitch="-90" roll="0" scale="1.5" mesh="laserbeam.mesh" />
+      <Model position="0,60,-40" yaw="90" pitch="-90" roll="0" scale="1.5" mesh="LaserBeam.mesh" />
       <Model position="0,80,-40" yaw="90" pitch="-90" roll="0" scale="2" mesh="rocket.mesh" />
       <Model position="0,-20,-40" yaw="90" pitch="-90" roll="0" scale="5" mesh="hs-w01.mesh" />
Index: code/branches/presentationHS12/data/levels/includes/weaponSettingsEscort.oxi
===================================================================
--- code/branches/presentationHS12/data/levels/includes/weaponSettingsEscort.oxi	(revision 9503)
+++ code/branches/presentationHS12/data/levels/includes/weaponSettingsEscort.oxi	(revision 9505)
@@ -19,6 +19,6 @@
             <Model mesh="hs-w01_reduced.mesh" roll="90" pitch="-76" yaw="-90" position="-1.5,1,0.3" scale=0.6 /-->
           </attached>
-          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 0.1, 1.6,-2" />
-          <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-1.6, 1.3,-2" />
+          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 0.1, 1.6,-2" projectileMesh="LaserBeam.mesh" />
+          <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-1.6, 1.3,-2" projectileMesh="LaserBeam.mesh" />
           <LightningGun mode=1 muzzleoffset="0,0,0" damage=3.14159 shielddamage=20 />
         </Weapon>
@@ -29,6 +29,6 @@
             <Model mesh="hs-w01_reduced.mesh" roll="90" pitch="-104" yaw="-90" position="0,1.3,0.3" scale=0.6 /-->
           </attached>
-          <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 1.6, 1.3, -2.0" />
-          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-0.1, 1.6, -2.0" />
+          <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 1.6, 1.3, -2.0" projectileMesh="LaserBeam.mesh" />
+          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-0.1, 1.6, -2.0" projectileMesh="LaserBeam.mesh" />
           <LightningGun mode=1 muzzleoffset="0,0,0" damage=23 />
         </Weapon>
Index: code/branches/presentationHS12/data/levels/templates/lodInformation.oxt
===================================================================
--- code/branches/presentationHS12/data/levels/templates/lodInformation.oxt	(revision 9503)
+++ code/branches/presentationHS12/data/levels/templates/lodInformation.oxt	(revision 9505)
@@ -16,4 +16,5 @@
       <MeshLodInformation mesh=HydroHarvester.mesh enabled=false />
       <MeshLodInformation mesh=turretHead.mesh enabled=false />
+      <MeshLodInformation mesh=LaserBeam.mesh enabled=false/>
 
       <!-- disable LOD for some debris meshes which caused a crash (fixed in Ogre 1.7.3) -->
Index: code/branches/presentationHS12/src/modules/weapons/weaponmodes/HsW01.cc
===================================================================
--- code/branches/presentationHS12/src/modules/weapons/weaponmodes/HsW01.cc	(revision 9503)
+++ code/branches/presentationHS12/src/modules/weapons/weaponmodes/HsW01.cc	(revision 9505)
@@ -61,9 +61,12 @@
         this->delay_ = 0.0f;
         this->setMunitionName("LaserMunition");
+        this->mesh_ = "laserbeam.mesh";
+        this->sound_ = "sounds/Weapon_HsW01.ogg";
+
 
         this->delayTimer_.setTimer(1.0f, false, createExecutor(createFunctor(&HsW01::shot, this)));
         this->delayTimer_.stopTimer();
 
-        this->setDefaultSound("sounds/Weapon_HsW01.ogg");
+        this->setDefaultSound(this->sound_);
     }
 
@@ -78,4 +81,6 @@
         XMLPortParam(HsW01, "delay", setDelay, getDelay, xmlelement, mode);
         XMLPortParam(HsW01, "material", setMaterial, getMaterial, xmlelement, mode);
+        XMLPortParam(HsW01, "projectileMesh", setMesh, getMesh, xmlelement, mode);
+	XMLPortParam(HsW01, "sound", setSound, getSound, xmlelement, mode);
     }
 
@@ -108,5 +113,5 @@
         Projectile* projectile = new Projectile(this);
         Model* model = new Model(projectile);
-        model->setMeshSource("laserbeam.mesh");
+        model->setMeshSource(mesh_);
         model->setCastShadows(false);
         projectile->attach(model);
Index: code/branches/presentationHS12/src/modules/weapons/weaponmodes/HsW01.h
===================================================================
--- code/branches/presentationHS12/src/modules/weapons/weaponmodes/HsW01.h	(revision 9503)
+++ code/branches/presentationHS12/src/modules/weapons/weaponmodes/HsW01.h	(revision 9505)
@@ -61,4 +61,32 @@
         private:
             /**
+            @brief Set the mesh.
+            @param mesh The mesh name.
+            */
+            void setMesh(const std::string& mesh)
+                { this->mesh_ = mesh; }
+
+            /**
+            @brief Get the mesh.
+            @return Returns the mesh name.
+            */
+            const std::string& getMesh() const
+                { return this->mesh_; }
+
+	    /**
+            @brief Set the sound.
+            @param mesh The Sound name.
+            */
+            void setSound(const std::string& sound)
+                { this->sound_ = sound; }
+
+	    /**
+            @brief Get the sound.
+            @return Returns the sound name.
+            */
+            const std::string& getSound() const
+                { return this->sound_; }
+
+            /**
             @brief Set the material.
             @param material The material name.
@@ -85,4 +113,9 @@
 
             std::string material_; //!< The material.
+            std::string mesh_; //!< The mesh.
+            std::string sound_; //!< The sound.
+
+
+
             float speed_; //!< The speed of the fired projectile.
             float delay_; //!< The firing delay.