Index: /branches/proxy/src/lib/network/server_socket.h
===================================================================
--- /branches/proxy/src/lib/network/server_socket.h	(revision 9512)
+++ /branches/proxy/src/lib/network/server_socket.h	(revision 9513)
@@ -1,6 +1,6 @@
 /*!
  * @file server_socket.h
- *  waits for incoming connections
-
+ * waits for incoming connections and handles them.
+ *
  */
 
Index: /branches/proxy/src/util/object_manager.cc
===================================================================
--- /branches/proxy/src/util/object_manager.cc	(revision 9512)
+++ /branches/proxy/src/util/object_manager.cc	(revision 9513)
@@ -134,5 +134,5 @@
   if (omList != OM_INIT || omList == OM_SIZE)
   {
-    PRINT(0)(" +ObjectManager-LIST: '%s'==size='%d'==---\n", ObjectManager::OMListToString((OM_LIST)omList), this->objectLists[omList].size());
+    PRINT(0)(" +ObjectManager-LIST: '%s'==size='%d'==---\n", ObjectManager::OMListToString((OM_LIST)omList).c_str(), this->objectLists[omList].size());
   //  if (level >= 1)
     {
@@ -174,8 +174,8 @@
  * @returns the String transformed from omList.
  */
-const char* ObjectManager::OMListToString(OM_LIST omList)
+const std::string& ObjectManager::OMListToString(OM_LIST omList)
 {
   if (omList == OM_INIT || omList == OM_SIZE)
-    return "===invalid===";
+    return ObjectManager::objectManagerListNames[0];
 
   printf("%d\n", omList);
@@ -199,10 +199,10 @@
     }
   }
-  return OM_DEFAULT_LIST;
-}
-
-
-
-const char* ObjectManager::objectManagerListNames[] = {
+  return OM_NULL;
+}
+
+
+
+const std::string ObjectManager::objectManagerListNames[] = {
     "null",
     "dead",
Index: /branches/proxy/src/util/object_manager.h
===================================================================
--- /branches/proxy/src/util/object_manager.h	(revision 9512)
+++ /branches/proxy/src/util/object_manager.h	(revision 9513)
@@ -96,5 +96,5 @@
 
   static OM_LIST StringToOMList(const std::string& listName);
-  static const char* OMListToString(OM_LIST omList);
+  static const std::string& OMListToString(OM_LIST omList);
 
 
@@ -113,5 +113,5 @@
   EntityList                              objectLists[OM_SIZE];     //!< The ObjectLists.
 
-  static const char*                      objectManagerListNames[]; //!< Names of all the lists
+  static const std::string                objectManagerListNames[]; //!< Names of all the lists
 
   EntityList                              reflectionList;           //!< A list of all reflected objects in the world
Index: /branches/proxy/src/world_entities/npcs/ground_turret.cc
===================================================================
--- /branches/proxy/src/world_entities/npcs/ground_turret.cc	(revision 9512)
+++ /branches/proxy/src/world_entities/npcs/ground_turret.cc	(revision 9513)
@@ -80,5 +80,5 @@
 
 /**
- * loads a GroundTurret from a XML-element
+ * @brief loads a GroundTurret from a XML-element
  * @param root the XML-element to load from
  * @todo make the class Loadable
Index: /branches/proxy/src/world_entities/weapons/aim.h
===================================================================
--- /branches/proxy/src/world_entities/weapons/aim.h	(revision 9512)
+++ /branches/proxy/src/world_entities/weapons/aim.h	(revision 9513)
@@ -37,11 +37,11 @@
 
   inline void selectTarget(PNode* target) { this->setParent(target); };
-  inline PNode* getTarget(PNode* target) { return this->getParent(); };
+  inline PNode* getTarget(PNode* target) const { return this->getParent(); };
 
   void searchTarget();
 
-  void setRange(float range){this->range = range;};
-  void setAngle(float angle){this->angle = angle;};
-  void setGroup(OM_LIST group){this->group = group;};
+  void setRange(float range) {this->range = range;};
+  void setAngle(float angle) {this->angle = angle;};
+  void setGroup(OM_LIST group) {this->group = group;};
 
   void setSize(float size);
Index: /branches/proxy/src/world_entities/world_entity.cc
===================================================================
--- /branches/proxy/src/world_entities/world_entity.cc	(revision 9512)
+++ /branches/proxy/src/world_entities/world_entity.cc	(revision 9513)
@@ -141,4 +141,6 @@
   .describe("The Health the WorldEntity has at this moment")
   .defaultValues(1.0f);
+
+  LoadParam(root, "list", this, WorldEntity, toListS);
 }
 
@@ -478,4 +480,14 @@
 }
 
+void WorldEntity::toListS(const std::string& listName)
+{
+  OM_LIST id = ObjectManager::StringToOMList(listName);
+  if (id != OM_NULL)
+    this->toList(id);
+  else
+    PRINTF(2)("List %s not found\n", listName.c_str());
+}
+
+
 void WorldEntity::toReflectionList()
 {
@@ -822,5 +834,5 @@
   PRINT(0)("WorldEntity %s::%s  (DEBUG)\n", this->getClassCName(), this->getCName());
   this->debugNode();
-  PRINT(0)("List: %s ; ModelCount %d - ", ObjectManager::OMListToString(this->objectListNumber) , this->models.size());
+  PRINT(0)("List: %s ; ModelCount %d - ", ObjectManager::OMListToString(this->objectListNumber).c_str(), this->models.size());
   for (unsigned int i = 0; i < this->models.size(); i++)
   {
Index: /branches/proxy/src/world_entities/world_entity.h
===================================================================
--- /branches/proxy/src/world_entities/world_entity.h	(revision 9512)
+++ /branches/proxy/src/world_entities/world_entity.h	(revision 9513)
@@ -115,4 +115,5 @@
   /* --- Object Manager Block --- */
   void toList(OM_LIST list);
+  void toListS(const std::string& listName);
 
   void toReflectionList();