Index: /code/branches/presentationHS12/data/levels/collateralDamageDemo.oxw
===================================================================
--- /code/branches/presentationHS12/data/levels/collateralDamageDemo.oxw	(revision 9517)
+++ /code/branches/presentationHS12/data/levels/collateralDamageDemo.oxw	(revision 9518)
@@ -13,5 +13,5 @@
 
 <?lua
-  include("templates/spaceshipAssff2.oxt")
+  include("templates/spaceshipAssff.oxt")
   include("templates/spaceshipPirate.oxt")
   include("templates/spaceshipCollateralDamage.oxt")
Index: /code/branches/presentationHS12/data/levels/emptyLevel.oxw
===================================================================
--- /code/branches/presentationHS12/data/levels/emptyLevel.oxw	(revision 9517)
+++ /code/branches/presentationHS12/data/levels/emptyLevel.oxw	(revision 9518)
@@ -1,6 +1,6 @@
 <LevelInfo
- name = "Empty level"
- description = "A level with absolutely nothing in it."
- tags = "test"
+ name = "Presentation HS 2012"
+ description = "Orxonox Proudly Presents"
+ tags = "presentation"
  screenshot = "emptylevel.png"
 />
Index: /code/branches/presentationHS12/data/levels/includes/weaponSettingsEscort.oxi
===================================================================
--- /code/branches/presentationHS12/data/levels/includes/weaponSettingsEscort.oxi	(revision 9517)
+++ /code/branches/presentationHS12/data/levels/includes/weaponSettingsEscort.oxi	(revision 9518)
@@ -14,22 +14,10 @@
         </links>
         <Weapon>
-          <attached>
-            <!--Model mesh="LightningGun.mesh" pitch="100" roll="90" yaw="90" position="0,0,0" />
-            <Model mesh="LightningGun-s.mesh" pitch="78" roll="90" yaw="90" position="0.2,-1.3,0" />
-            <Model mesh="hs-w01_reduced.mesh" roll="90" pitch="-76" yaw="-90" position="-1.5,1,0.3" scale=0.6 /-->
-          </attached>
-          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 0.1, 1.6,-2" projectileMesh="LaserBeam.mesh" />
-          <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-1.6, 1.3,-2" projectileMesh="LaserBeam.mesh" />
-          <LightningGun mode=1 muzzleoffset="0,0,0" damage=3.14159 shielddamage=20 />
+          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=9.3 material="Flares/point_lensflare" muzzleoffset=" 0.1, 1.6,-2" projectileMesh="LaserBeam.mesh" />
+          <!--HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-1.6, 1.3,-2" projectileMesh="LaserBeam.mesh" /-->
         </Weapon>
         <Weapon>
-          <attached>
-            <!--Model mesh="LightningGun.mesh" pitch="103" roll="90" yaw="90" position="0,0,0" />
-            <Model mesh="LightningGun-s.mesh" pitch="103" roll="90" yaw="90" position="0.2,-1.35,0" />
-            <Model mesh="hs-w01_reduced.mesh" roll="90" pitch="-104" yaw="-90" position="0,1.3,0.3" scale=0.6 /-->
-          </attached>
-          <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 1.6, 1.3, -2.0" projectileMesh="LaserBeam.mesh" />
-          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-0.1, 1.6, -2.0" projectileMesh="LaserBeam.mesh" />
-          <LightningGun mode=1 muzzleoffset="0,0,0" damage=23 />
+          <HsW01 mode=0 munitionpershot=0 delay=0     damage=9.3 material="Flares/point_lensflare" muzzleoffset=" 1.6, 1.3, -2.0" projectileMesh="LaserBeam.mesh" />
+          <!--HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-0.1, 1.6, -2.0" projectileMesh="LaserBeam.mesh" /-->
         </Weapon>
       </WeaponPack>
Index: /code/branches/presentationHS12/data/levels/templates/bigship.oxt
===================================================================
--- /code/branches/presentationHS12/data/levels/templates/bigship.oxt	(revision 9517)
+++ /code/branches/presentationHS12/data/levels/templates/bigship.oxt	(revision 9518)
@@ -2,5 +2,5 @@
   <SpaceShip
    hudtemplate            = spaceshiphud
-   camerapositiontemplate = spaceshipassffcameras
+   camerapositiontemplate = bigshipcameras
    spawnparticlesource    = "Orxonox/fairytwirl"
    spawnparticleduration  = 3
@@ -25,7 +25,7 @@
    stallSpeed = 220;
 
-   boostPower            = 15
-   boostPowerRate        = 1
-   boostRate             = 5
+   boostPower            = 30
+   boostPowerRate        = 1.5
+   boostRate             = 4
    boostCooldownDuration = 10
 
@@ -39,6 +39,6 @@
   >
     <engines>
-      <MultiStateEngine position=" 15, 0, 0" template=spaceshipassffengine />
-      <MultiStateEngine position="-15, 0, 0" template=spaceshipassffengine />
+      <MultiStateEngine position=" 15, 0, 0" template=bigshipengine />
+      <MultiStateEngine position="-15, 0, 0" template=bigshipengine />
     </engines>
     <attached>
@@ -89,15 +89,15 @@
 </Template>
 
-<Template name=spaceshipassffcameras defaults=0>
+<Template name=bigshipcameras defaults=0>
   <SpaceShip>
     <camerapositions>
       <CameraPosition position="0,30, 50" drag=true mouselook=true />
-      <CameraPosition position="0,40, 80" drag=true mouselook=true />
       <CameraPosition position="0,10,80" drag=true mouselook=true />
+      <CameraPosition position="0,40,120" drag=true mouselook=true />
     </camerapositions>
   </SpaceShip>
 </Template>
 
-<Template name=spaceshipassffengine baseclass=MultiStateEngine>
+<Template name=bigshipengine baseclass=MultiStateEngine>
   <MultiStateEngine
    boostfactor    = 2
Index: /code/branches/presentationHS12/data/levels/templates/spaceshipCollateralDamage.oxt
===================================================================
--- /code/branches/presentationHS12/data/levels/templates/spaceshipCollateralDamage.oxt	(revision 9517)
+++ /code/branches/presentationHS12/data/levels/templates/spaceshipCollateralDamage.oxt	(revision 9518)
@@ -3,12 +3,12 @@
   <SpaceShip
    hudtemplate            = spaceshiphud
-   camerapositiontemplate = spaceshipassffcameras
+   camerapositiontemplate = spaceshipCDcameras
    spawnparticlesource    = "Orxonox/fairytwirl"
    spawnparticleduration  = 3
    explosionchunks        = 6
 
-   health            = 100
-   maxhealth         = 200
-   initialhealth     = 100
+   health            = 200
+   maxhealth         = 400
+   initialhealth     = 200
 
    shieldhealth        = 30
@@ -40,6 +40,6 @@
   >
     <engines>
-      <MultiStateEngine position=" 7.6, 0, 6" template=spaceshipassffengine />
-      <MultiStateEngine position="-7.6, 0, 0" template=spaceshipassffengine />
+      <MultiStateEngine position=" 7.6, 0, 6" template=spaceshipCDengine />
+      <MultiStateEngine position="-7.6, 0, 0" template=spaceshipCDengine />
     </engines>
     <attached>
@@ -71,5 +71,5 @@
 </Template>
 
-<Template name=spaceshipassffcameras defaults=0>
+<Template name=spaceshipCDcameras defaults=0>
   <SpaceShip>
     <camerapositions>
@@ -82,5 +82,5 @@
 </Template>
 
-<Template name=spaceshipassffengine baseclass=MultiStateEngine>
+<Template name=spaceshipCDengine baseclass=MultiStateEngine>
   <MultiStateEngine
    boostfactor    = 5
@@ -118,6 +118,6 @@
 
     <EffectContainer condition="normal or boost">
-      <Backlight mainstate=activity active=false scale=0.4 name=bltest position=" 8, 0, 12" colour="1, 0.8, 0, 0.3" width=6 length=1500 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=3 turnofftime=1 material="Flares/ThrusterFlare2" />
-      <Backlight mainstate=activity active=false scale=0.4 name=bltest position="-8, 0, 12" colour="1, 0.8, 0, 0.3" width=6 length=1500 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=3 turnofftime=1 material="Flares/ThrusterFlare2" />
+      <Backlight mainstate=activity active=false scale=0.4 name=bltest position=" 8, 0, 12" colour="1, 0.8, 0, 0.3" width=6 length=1500 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=3 turnofftime=1 material="Flares/ThrusterFlare1" />
+      <Backlight mainstate=activity active=false scale=0.4 name=bltest position="-8, 0, 12" colour="1, 0.8, 0, 0.3" width=6 length=1500 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=3 turnofftime=1 material="Flares/ThrusterFlare1" />
 
       <FadingBillboard mainstate=activity active=false scale=0.05 position="8, -1, 12" colour="1, 0.8, 0, 0.3" material="Examples/Flare" turnontime=1 turnofftime=0.5 />
Index: /code/branches/presentationHS12/data/levels/templates/spaceshipEscort.oxt
===================================================================
--- /code/branches/presentationHS12/data/levels/templates/spaceshipEscort.oxt	(revision 9517)
+++ /code/branches/presentationHS12/data/levels/templates/spaceshipEscort.oxt	(revision 9518)
@@ -2,5 +2,5 @@
   <SpaceShip
    hudtemplate            = spaceshiphud
-   camerapositiontemplate = spaceshipassffcameras
+   camerapositiontemplate = spaceshipescortcameras
    spawnparticlesource    = "Orxonox/fairytwirl"
    spawnparticleduration  = 3
@@ -39,6 +39,6 @@
   >
     <engines>
-      <MultiStateEngine position=" 7.6, 0, 6" template=spaceshipassffengine />
-      <MultiStateEngine position="-7.6, 0, 0" template=spaceshipassffengine />
+      <MultiStateEngine position=" 7.6, 0, 6" template=spaceshipescortengine />
+      <MultiStateEngine position="-7.6, 0, 0" template=spaceshipescortengine />
     </engines>
     <attached>
@@ -62,9 +62,9 @@
 </Template>
 
-<Template name=spaceshipassffcameras defaults=0>
+<Template name=spaceshipescortcameras defaults=0>
   <SpaceShip>
     <camerapositions>
-      <CameraPosition position="0,13, 40" drag=true mouselook=true />
-      <CameraPosition position="0,20, 80" drag=true mouselook=true />
+      <CameraPosition position="0,15, 60" drag=true mouselook=true />
+      <CameraPosition position="0,20, 90" drag=true mouselook=true />
       <CameraPosition position="0,30,120" drag=true mouselook=true />
     </camerapositions>
@@ -72,5 +72,5 @@
 </Template>
 
-<Template name=spaceshipassffengine baseclass=MultiStateEngine>
+<Template name=spaceshipescortengine baseclass=MultiStateEngine>
   <MultiStateEngine
    boostfactor    = 2.2
Index: /code/branches/presentationHS12/data/levels/templates/spaceshipTurret.oxt
===================================================================
--- /code/branches/presentationHS12/data/levels/templates/spaceshipTurret.oxt	(revision 9517)
+++ /code/branches/presentationHS12/data/levels/templates/spaceshipTurret.oxt	(revision 9518)
@@ -2,5 +2,5 @@
   <SpaceShip
    hudtemplate            = spaceshiphud
-   camerapositiontemplate = spaceshipassffcameras
+   camerapositiontemplate = spaceshipturretcameras
    spawnparticlesource    = "Orxonox/fairytwirl"
    spawnparticleduration  = 3
@@ -49,2 +49,12 @@
   </SpaceShip>
 </Template>
+
+<Template name=spaceshipturretcameras defaults=0>
+  <SpaceShip>
+    <camerapositions>
+      <CameraPosition position="0,10, 40" drag=true mouselook=true />
+      <CameraPosition position="0,20, 80" drag=true mouselook=true />
+      <CameraPosition position="0,30,120" drag=true mouselook=true />
+    </camerapositions>
+  </SpaceShip>
+</Template>