Index: code/branches/presentationHS12/data/levels/presentationHS12.oxw
===================================================================
--- code/branches/presentationHS12/data/levels/presentationHS12.oxw	(revision 9520)
+++ code/branches/presentationHS12/data/levels/presentationHS12.oxw	(revision 9521)
@@ -39,8 +39,20 @@
   <?lua include("includes/notifications.oxi") ?>
 
+  <NotificationQueueCEGUI
+    name="narrative"
+    targets="simpleNotification"
+    size=1
+    displayTime=30
+    position="0.2, 0, 0.1, 0"
+    fontSize="24"
+    fontColor="0.3, 1, 0.2, 0.8"
+    alignment="HorzCentred"
+    displaySize="0.6, 0, 0, 0"
+    />
+
   <Scene
     ambientlight = "0.8, 0.8, 0.8"
-    skybox       = "Orxonox/Starbox"
-  >
+    skybox       = "Orxonox/skyBoxMoreNebula"
+  > <!-- Orxonox/Starbox -->
     <?lua
       include("includes/pickups.oxi")
@@ -48,50 +60,51 @@
 
     <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0"/>
-    <!--SpawnPoint team=0 position="-800,0,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipescort /-->
+    <SpawnPoint team=0 position="-800,0,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipescort />
     <!--SpawnPoint team=0 position="-200,0,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=bigship /-->
-    <SpawnPoint team=0 position="-900,0,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipcollateraldamage />
+    <!--SpawnPoint team=0 position="-900,0,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipcollateraldamage /-->
+    <!--SpawnPoint team=0 position="6000,0,2000" lookat="1,1,0" spawnclass=SpaceShip pawndesign=spaceshipcollateraldamage /-->
     
     <SpaceRaceManager>
         <checkpoints>
-            <RaceCheckPoint name="checkpoint1" position="000,0,0" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="0" islast="false" nextcheckpoints="1,2,3">
-                <attached>
-                    <Model mass="50" scale="7" mesh="BigSpacegate.mesh" yaw=90 />
+            <RaceCheckPoint name="checkpoint1" position="000,0,0" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="0" islast="false" nextcheckpoints="1,2,3">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=90 />
                 </attached>
             </RaceCheckPoint>
 <!--- first three alternative paths --->
-            <RaceCheckPoint name="checkpoint2" position="1300,0,-800" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="1" islast="false" nextcheckpoints="7,-1,-1">
-                <attached>
-                    <Model mass="50" scale="7" mesh="BigSpacegate.mesh" yaw=90/>
-                </attached>
-            </RaceCheckPoint>
-
-            <RaceCheckPoint name="checkpoint3" position="1200,-400,0" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="2" islast="false" nextcheckpoints="5,-1,-1">
-                <attached>
-                    <Model mass="50" scale="7" mesh="BigSpacegate.mesh" yaw=90 />
-                </attached>
-            </RaceCheckPoint>
-
-            <RaceCheckPoint name="checkpoint4" position="1200,100,700" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="3" islast="false" nextcheckpoints="6,-1,-1">
-                <attached>
-                    <Model mass="50" scale="7" mesh="BigSpacegate.mesh" yaw=90 />
+            <RaceCheckPoint name="checkpoint2" position="1300,0,-800" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="1" islast="false" nextcheckpoints="7,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=90/>
+                </attached>
+            </RaceCheckPoint>
+
+            <RaceCheckPoint name="checkpoint3" position="1200,-400,0" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="2" islast="false" nextcheckpoints="5,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=90 />
+                </attached>
+            </RaceCheckPoint>
+
+            <RaceCheckPoint name="checkpoint4" position="1200,100,700" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="3" islast="false" nextcheckpoints="6,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=90 />
                 </attached>
             </RaceCheckPoint>
 
 <!--- second three alternative paths --->
-            <!--RaceCheckPoint name="checkpoint5" position="2000,500,-400" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="4" islast="false" nextcheckpoints="7,-1,-1">
-                <attached>
-                    <Model mass="50" scale="7" mesh="BigSpacegate.mesh" yaw=90 />
+            <!--RaceCheckPoint name="checkpoint5" position="2000,500,-400" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="4" islast="false" nextcheckpoints="7,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=90 />
                 </attached>
             </RaceCheckPoint-->
 
-            <RaceCheckPoint name="checkpoint6" position="2000,0,0" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="5" islast="false" nextcheckpoints="8,9,-1">
-                <attached>
-                    <Model mass="50" scale="7" mesh="BigSpacegate.mesh" yaw=90 />
-                </attached>
-            </RaceCheckPoint>
-
-            <RaceCheckPoint name="checkpoint7" position="2000,-500,400" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="6" islast="false" nextcheckpoints="10,-1,-1">
-                <attached>
-                    <Model mass="50" scale="7" mesh="BigSpacegate.mesh" yaw=90 />
+            <RaceCheckPoint name="checkpoint6" position="2000,0,0" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="5" islast="false" nextcheckpoints="8,9,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=90 />
+                </attached>
+            </RaceCheckPoint>
+
+            <RaceCheckPoint name="checkpoint7" position="2000,-500,400" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="6" islast="false" nextcheckpoints="10,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=90 />
                 </attached>
             </RaceCheckPoint>
@@ -100,43 +113,82 @@
 <!--- third generation --->
 
-            <RaceCheckPoint name="checkpoint8" position="5000,0,-3000" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="7" islast="false" nextcheckpoints="12,-1,-1">
-                <attached>
-                    <Model mass="50" scale="7" mesh="BigSpacegate.mesh" yaw=135 />
-                </attached>
-            </RaceCheckPoint>
-
-            <RaceCheckPoint name="checkpoint9" position="3500,800,0" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="8" islast="false" nextcheckpoints="11,-1,-1">
-                <attached>
-                    <Model mass="50" scale="7" mesh="BigSpacegate.mesh" yaw=90 />
-                </attached>
-            </RaceCheckPoint>
-
-            <RaceCheckPoint name="checkpoint10" position="3500,-800,0" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="9" islast="false" nextcheckpoints="11,-1,-1">
-                <attached>
-                    <Model mass="50" scale="7" mesh="BigSpacegate.mesh" yaw=90 />
-                </attached>
-            </RaceCheckPoint>
-
-            <RaceCheckPoint name="checkpoint11" position="3500,0,1000" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="10" islast="false" nextcheckpoints="12,-1,-1">
-                <attached>
-                    <Model mass="50" scale="7" mesh="BigSpacegate.mesh" yaw=90 />
-                </attached>
-            </RaceCheckPoint>
-
-<!-- Intermediate -->
-            <RaceCheckPoint name="checkpoint12" position="4500,0,-100" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="11" islast="false" nextcheckpoints="12,-1,-1">
-                <attached>
-                    <Model mass="50" scale="7" mesh="BigSpacegate.mesh" yaw=90 />
-                </attached>
-            </RaceCheckPoint>
-
-<!----  GOAL  ---->
-            <RaceCheckPoint name="checkpoint13" position="6000,0,2000" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="12" islast="true">
-                <attached>
-                    <Model mass="50" scale="7" mesh="BigSpacegate.mesh" yaw=100 />
+            <RaceCheckPoint name="checkpoint8" position="5000,0,-3000" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="7" islast="false" nextcheckpoints="12,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=135 />
+                </attached>
+            </RaceCheckPoint>
+
+            <RaceCheckPoint name="checkpoint9" position="3500,800,0" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="8" islast="false" nextcheckpoints="11,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=90 />
+                </attached>
+            </RaceCheckPoint>
+
+            <RaceCheckPoint name="checkpoint10" position="3500,-800,0" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="9" islast="false" nextcheckpoints="11,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=90 />
+                </attached>
+            </RaceCheckPoint>
+
+            <RaceCheckPoint name="checkpoint11" position="3500,0,1000" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="10" islast="false" nextcheckpoints="12,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=90 />
+                </attached>
+            </RaceCheckPoint>
+
+<!-- Intermediate Solo Gate -->
+            <RaceCheckPoint name="checkpoint12" position="4500,0,-100" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="11" islast="false" nextcheckpoints="12,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=90 />
+                </attached>
+            </RaceCheckPoint>
+
+<!----  First Common Point  ---->
+            <RaceCheckPoint name="checkpoint13" position="6000,0,2000" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="12" islast="false" nextcheckpoints="13,14,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=100 pitch=45 />
+                </attached>
+            </RaceCheckPoint>
+
+<!-- Two Paths (1) -->
+            <RaceCheckPoint name="checkpoint14" position="7500,-1500,2500" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="13" islast="false" nextcheckpoints="15,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=100 pitch=130 roll=1 />
+                    <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.6,0.4,0.1" scale=3 />
+                </attached>
+            </RaceCheckPoint>
+
+            <RaceCheckPoint name="checkpoint15" position="7500,-1500,1500" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="14" islast="false" nextcheckpoints="16,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=100 pitch=90 />
+                </attached>
+            </RaceCheckPoint>
+
+<!-- Two Paths (2) -->
+            <RaceCheckPoint name="checkpoint16" position="9000,-3000, 3000" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="15" islast="false" nextcheckpoints="17,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=100 pitch=130 roll=1 />
+                    <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.2,0.4,0.8" scale=3 />
+                </attached>
+            </RaceCheckPoint>
+
+            <RaceCheckPoint name="checkpoint17" position="9000,-3000,1000" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="16" islast="false" nextcheckpoints="17,-1,-1">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=100 pitch=110 />
+                </attached>
+            </RaceCheckPoint>
+
+<!-- GOAL -->
+            <RaceCheckPoint name="checkpoint18" position="12000,-4000,2000" direction="0,-1,1" collisionType="static" scale="1" distance="70" checkpointindex="17" islast="true">
+                <attached>
+                    <Model mass="50" scale="6" mesh="BigSpacegate.mesh" yaw=100 pitch=135 />
                 </attached>
             </RaceCheckPoint>
         </checkpoints>
     </SpaceRaceManager>
+
+
+
+
 
 <!-- Simplify paths -->
@@ -158,9 +210,162 @@
 
     <!-- ForceField -->
-
+800,400,0
+        <ForceField position="1200,-400,0" direction="8,4,0" diameter=500 velocity=2000 length=500 />
+        <MovableEntity position="1200,-400,0">
+            <attached>
+                <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.1,0.1,0.1" scale=1/>
+                <?lua for i=0,4,1 do ?>
+                    <Billboard position="<?lua print(i*200) ?>,<?lua print(i*100) ?>,-100" material="Examples/Flare" colour="0.1,0.1,0.1" scale=1/>
+                    <Billboard position="<?lua print(i*200) ?>,<?lua print(i*100) ?>,100" material="Examples/Flare" colour="0.1,0.1,0.1" scale=1/>
+                <?lua end ?>
+                </attached>
+        </MovableEntity>
 
 
    <!-- Pickup -->
-   <PickupSpawner pickup=mediumspeedpickup position="5300,0,-2300" triggerDistance="60" respawnTime="10" maxSpawnedItems="99" scale="12" />
+   <PickupSpawner pickup=smallspeedpickup position="5300,0,-2300" triggerDistance="60" respawnTime="10" maxSpawnedItems="99" scale="12" />
+
+
+<!--- SCENERY --->
+    <!-- @Objects: HYDROGEN FARMER-->
+    <StaticEntity position="5700,0,-3700" mass=10000 >
+      <attached>
+        <Model mesh="HydroHarvester.mesh" mass=10 position="0,0,0" scale=50 />
+        <ParticleEmitter position="0,0,0" source="Orxonox/ThrusterFire" scale=1.2 />
+   <!-- <Model mesh="cube.mesh" mass=10 position="-560,0,0" scale3D="115,100,245"  />
+        <Model mesh="cube.mesh" mass=10 position="290,0,-480" scale3D="115,100,245" yaw=-120 />
+        <Model mesh="cube.mesh" mass=10 position="290,0,480" scale3D="115,100,245" yaw=-240 />
+        <Model mesh="cube.mesh" mass=10 position="-280,0,0" scale3D="163,50,50" />
+        <Model mesh="cube.mesh" mass=10 position="140,0,-240" scale3D="163,50,50"  yaw=-120/>
+        <Model mesh="cube.mesh" mass=10 position="140,0,240" scale3D="163,50,50" yaw=-240/>
+        <Model mesh="cube.mesh" mass=10 position="0,530,0" scale3D="172,52,298" />
+        <Model mesh="cube.mesh" mass=10 position="0,530,0" scale3D="172,52,298" yaw=-120/>
+        <Model mesh="cube.mesh" mass=10 position="0,530,0" scale3D="172,52,298" yaw=-240/>
+        <Model mesh="cube.mesh" mass=10 position="0,400,0" scale3D="43,110,26" yaw=-30 />
+        <Model mesh="cube.mesh" mass=10 position="-200,100,0" scale3D="26,50,43" />
+        <Model mesh="cube.mesh" mass=10 position="100,100,-173" scale3D="43,50,26" yaw=-30/>
+        <Model mesh="cube.mesh" mass=10 position="100,100,173" scale3D="43,50,26" yaw=30/>
+        <Model mesh="cube.mesh" mass=10 position="-100,264,0" scale3D="26,105,43" roll=-49/>
+        <Model mesh="cube.mesh" mass=10 position="50,264,-87" scale3D="26,105,43" roll=-49 yaw=-120/>
+        <Model mesh="cube.mesh" mass=10 position="50,264,87" scale3D="26,105,43" roll=-49 yaw=-240/>     -->
+      </attached>
+      <collisionShapes>
+        <BoxCollisionShape  position="-560,0,0" halfExtents="115,100,245" /><!-- Three lower boxes -->
+        <BoxCollisionShape  position="290,0,-480" halfExtents="115,100,245" yaw=-120 />
+        <BoxCollisionShape  position="290,0,480" halfExtents="115,100,245" yaw=-240 />
+        <BoxCollisionShape  position="-280,0,0" halfExtents="163,50,50" /><!-- Three lower connections -->
+        <BoxCollisionShape  position="140,0,-240" halfExtents="163,50,50" yaw=-120 />
+        <BoxCollisionShape  position="140,0,240" halfExtents="163,50,50" yaw=-240 />
+        <BoxCollisionShape  position="0,530,0" halfExtents="172,52,298" /><!-- Upper Tower -->
+        <BoxCollisionShape  position="0,530,0" halfExtents="172,52,298" yaw=-120 />
+        <BoxCollisionShape  position="0,530,0" halfExtents="172,52,298" yaw=-240 />
+        <BoxCollisionShape  position="0,400,0" halfExtents="43,110,26" yaw=-30 /><!-- Middle one-->
+        <BoxCollisionShape  position="-200,100,0" halfExtents="26,50,43" /><!--Three lower legs -->
+        <BoxCollisionShape  position="100,100,-173" halfExtents="43,50,26" yaw=-30 />
+        <BoxCollisionShape  position="100,100,-173" halfExtents="43,50,26" yaw=30 />
+        <BoxCollisionShape  position="-100,264,0" halfExtents="26,105,43" roll=-49 /><!--Three upper legs -->
+        <BoxCollisionShape  position="50,264,-87" halfExtents="26,105,43" roll=-49 yaw=-120 />
+        <BoxCollisionShape  position="50,264,87" halfExtents="26,105,43" roll=-49 yaw=-240 />
+      </collisionShapes>
+    </StaticEntity>
+
+    <StaticEntity position="2800,0,0" mass=10000 pitch=0 roll=45 yaw=240 >
+      <attached>
+	<Model position="0,0,0" yaw=0 pitch=180 roll=0 scale=40 mesh="bsBody.mesh" />
+	<Model position="0,0,0" yaw=0 pitch=180 roll=0 scale=40 mesh="bsDuseL.mesh" />
+	<Model position="0,0,0" yaw=0 pitch=180 roll=0 scale=40 mesh="bsDuseR.mesh" />
+	<Model position="0,0,0" yaw=0 pitch=180 roll=0 scale=40 mesh="bsKuppelV.mesh" />
+	<Model position="0,0,0" yaw=0 pitch=180 roll=0 scale=40 mesh="bsKuppelK.mesh" />
+	<Model position="0,0,0" yaw=0 pitch=180 roll=0 scale=40 mesh="bsAntL.mesh" />
+	<Model position="0,0,0" yaw=0 pitch=180 roll=0 scale=40 mesh="bsAntR.mesh" />
+	<Model position="0,0,0" yaw=0 pitch=180 roll=0 scale=40 mesh="bsGarage.mesh" />
+	<Model position="0,0,0" yaw=0 pitch=180 roll=0 scale=40 mesh="bsStation.mesh" />
+
+	<BlinkingBillboard position="20,-24,160" material="Examples/Flare" colour="0.3, 0.3, 1, 0.1" amplitude=0.2 frequency=0.4 phase=0 quadratic=1 />
+      	<BlinkingBillboard position="-20,-24,160" material="Examples/Flare" colour="0.3, 0.3, 1, 0.1" amplitude=0.2 frequency=0.4 phase=0 quadratic=1 />
+	<BlinkingBillboard position="20,-25,190" material="Examples/Flare" colour="0.3, 0.3, 1, 0.1" amplitude=0.2 frequency=0.4 phase=40 quadratic=1 />
+      	<BlinkingBillboard position="-20,-25,190" material="Examples/Flare" colour="0.3, 0.3, 1, 0.1" amplitude=0.2 frequency=0.4 phase=40 quadratic=1 />
+	<BlinkingBillboard position="20,-25,220" material="Examples/Flare" colour="0.3, 0.3, 1, 0.1" amplitude=0.2 frequency=0.4 phase=80 quadratic=0 />
+      	<BlinkingBillboard position="-20,-25,220" material="Examples/Flare" colour="0.3, 0.3, 1, 0.1" amplitude=0.2 frequency=0.4 phase=80 quadratic=0 />
+	<BlinkingBillboard position="20,-26,250" material="Examples/Flare" colour="0.3, 0.3, 1, 0.1" amplitude=0.2 frequency=0.4 phase=120 quadratic=0 />
+      	<BlinkingBillboard position="-20,-26,250" material="Examples/Flare" colour="0.3, 0.3, 1, 0.1" amplitude=0.2 frequency=0.4 phase=120 quadratic=0 />
+	<BlinkingBillboard position="20,-26,28" material="Examples/Flare" colour="0.3, 0.3, 1, 0.1" amplitude=0.2 frequency=0.4 phase=160 quadratic=0 />
+      	<BlinkingBillboard position="-20,-26,28" material="Examples/Flare" colour="0.3, 0.3, 1, 0.1" amplitude=0.2 frequency=0.4 phase=160 quadratic=0 />
+	<BlinkingBillboard position="29,-35,142" material="Examples/Flare" colour="1, 0.4, 0.4, 0.1" amplitude=0.2 frequency=30 phase=0 quadratic=0 />
+      	<BlinkingBillboard position="-29,-35,142" material="Examples/Flare" colour="1, 0.4, 0.4, 0.1" amplitude=0.2 frequency=30 phase=0 quadratic=0 />
+      </attached>
+    </StaticEntity>
+    <!-- triple large belt around the planet  -->
+    <?lua
+        dofile("includes/asteroidField.lua")
+        asteroidBelt(15000, 0, 0, 30, 0, 30, 30, 50, 7190, 7800, 250, 1)
+    ?>
+    <?lua
+        dofile("includes/asteroidField.lua")
+        asteroidBelt(15000, 0, 0, 30, 0, 30, 30, 50, 10000, 11000, 300, 1)
+    ?>
+    <?lua
+        dofile("includes/asteroidField.lua")
+        asteroidBelt(15000, 0, 0, 30, 0, 30, 30, 50, 14000, 15000, 350, 1)
+    ?>
+
+    <Planet
+      position="15000,0,-1000"
+      scale="5000"
+      collisionType="dynamic"
+      linearDamping="0.8"
+      angularDamping="0"
+      mass="10000000"
+      pitch="0"
+      mesh="planets/ganymede.mesh"
+      atmosphere="atmosphere1"
+      rotationaxis="1,0,0"
+      rotationrate="1.0"
+      atmospheresize="80.0f"
+      imagesize="1024.0f"
+      collisiondamage = 2
+      enablecollisiondamage = true
+    >
+      <attached>
+        <ForceField position="5000,0,0" mode="sphere" diameter="10000" velocity="-50" />
+      </attached>
+      <collisionShapes>
+        <SphereCollisionShape radius="5000" position="0,0,0" />
+      </collisionShapes>
+    </Planet>
+
+
+<!-- INTERACTIVE LEVEL -->
+    <DistanceTrigger name="start" position="-900,0,0"  target="Pawn" distance=100 stayActive="true" delay=0.5 />
+    <DistanceTrigger name="spawnBots" position="-900,0,0"  target="Pawn" distance=100 stayActive="true" delay=4.5 />
+
+    <SimpleNotification message="Sound Effetcs by Mike." broadcast="true">
+        <events>
+            <trigger>
+                <EventListener event=start />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
+    <Script code="addBots 3" onLoad="false">
+        <events>
+            <trigger>
+                <EventListener event=spawnBots />
+            </trigger>
+        </events>
+    </Script>
+
+
+<!-- SOUNDS & MUSIC -->
+            <WorldSound name="scoreSound" position="-900,0,0" source="sounds/ReadyGo.ogg" >
+              <events>
+                <play>
+                  <EventListener event="start" />
+                </play>
+              </events>
+            </WorldSound>
+
+
+
 
   </Scene>